/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is EZNav.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Portions of code were copied from GoUp by Stephen Clavering
 *                                   MozFBRH by Paradox
 *                                   NextImage by Ralph Churchill
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

window.addEventListener("load", ez_init, true);

function ez_init(){

	document.getElementById('back-button').addEventListener('click', function(event){ez_navigate(event, -1)}, true);
	document.getElementById('forward-button').addEventListener('click', function(event){ez_navigate(event, 1)}, true);
}


function ez_navigate(aEvent, mod) {
	// mod is the increment or decrement
	if (aEvent.button == 1) {
		
		var e,s;
	    var currentLoc = self._content.location.href;
	    var locLength = currentLoc.length;
	    for (e=locLength-1; e>=0; --e)
	        if (isDigit(currentLoc.charAt(e)))
	        {
	            for(s=e-1; s>=0; --s)
	                if (!isDigit(currentLoc.charAt(s)))
	                    break;
	                break;
	        }
        ++s;
        if (e<0)
            return;
        var oldNum = currentLoc.substring(s,e+1);
        var newNum = '' + (parseInt(oldNum,10) + mod);
        while (newNum.length < oldNum.length)
            newNum = '0' + newNum;
        self._content.location.href = currentLoc.substring(0,s) + newNum + currentLoc.slice(e+1);
		
	}
}

function ez_up(aEvent){
	
	if (aEvent.button == 1) {
		var url = self._content.location.href;
		var origUrl = self._content.location.href;
		var matches;
		
	    // trim filename (this makes subdriectory digging easier)
	    matches = url.match(/(^.*\/)(.*)/);
	    if(!matches)
	    	return; //only fails if "url" has no /'s
	    url = matches[1];
	    if(url!=origUrl && !/(index|main)\.(php3?|html?)/i.test(url)) {
	    	self._content.location.href = url;
	    	return;
	    }
	    	
	    // dig through subdirs
	    matches = url.match(/^([^\/]*?:\/\/.*\/)[^\/]+?\//);
	    if(matches) {
	    	self._content.location.href = matches[1];
	    	return;
	    }
	    
	    // we've reach (ht|f)tp://foo.com/, climb up through subdomains
	    // split into protocol and domain
	    matches = url.match(/([^:]*:\/\/)?(.*)/);
	    var protocol = matches[1], domain = matches[2];
	    matches = domain.match(/^[^\.]*\.(.*)/);;
	    if(matches) {
	    	self._content.location.href = protocol+matches[1];
	    	return;
	    }
	    
	    // nothing found
	    return;
	}
	
}

function ez_homeTab(aEvent){
	if (aEvent.button == 1) {
		BrowserOpenTab();
		BrowserHome();
	}
}

function isDigit(c) {
    var c_num = parseInt(c);
    return (0 <= c_num && c_num <= 9);
}